# -*- coding: utf-8 -*-
# file: metric_analysis.py
# time: 11:28 30/04/2024
# author: YANG, HENG <hy345@exeter.ac.uk> (杨恒)
# github: https://github.com/yangheng95
# huggingface: https://huggingface.co/yangheng
# google scholar: https://scholar.google.com/citations?user=NPq5a_0AAAAJ&hl=en
# Copyright (C) 2019-2024. All Rights Reserved.
import findfile
from metric_visualizer import MetricVisualizer
from metric_visualizer.utils import MetricList

# ----------------------------------------------------------------------------- Raw Metric Records -----------------------------------------------------------------------------
# +----------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
# ?Metric                  ?Trial                                                      ?Values                   ? Average  ? Median  ? Std   ? IQR   ? Min   ? Max   ?
# ?------------------------+------------------------------------------------------------+--------------------------+-----------+----------+--------+--------+--------+--------?
# ?mc_rmse                 ?rgb-genomic_foundation_models/3utrbert-RNA-mRNA            ?[0.7785, 0.7773, 0.7759] ? 0.7773   ? 0.7773  ?0.0011 ?0.0013 ?0.7759 ?0.7785 ?
# +-------------------------+------------------------------------------------------------+--------------------------+-----------+----------+--------+--------+--------+--------?
# ?roc_auc_score           ?rgb-genomic_foundation_models/3utrbert-RNA-SNMD            ?[0.4997, 0.5015, 0.4993] ? 0.5002   ? 0.4997  ?0.001  ?0.0011 ?0.4993 ?0.5015 ?
# +-------------------------+------------------------------------------------------------+--------------------------+-----------+----------+--------+--------+--------+--------?
# ?f1_score                ?rgb-genomic_foundation_models/3utrbert-RNA-SNMR            ?[0.2479, 0.2259, 0.2465] ? 0.2401   ? 0.2465  ?0.0101 ?0.011  ?0.2259 ?0.2479 ?
# +-------------------------+------------------------------------------------------------+--------------------------+-----------+----------+--------+--------+--------+--------?
# ?f1_score                ?rgb-genomic_foundation_models/3utrbert-RNA-SSP-Archive2    ?[0.7892, 0.7826, 0.7975] ? 0.7898   ? 0.7892  ?0.0061 ?0.0075 ?0.7826 ?0.7975 ?
# +-------------------------+------------------------------------------------------------+--------------------------+-----------+----------+--------+--------+--------+--------?
# ?f1_score                ?rgb-genomic_foundation_models/3utrbert-RNA-SSP-bpRNA       ?[0.5671, 0.5647, 0.5762] ? 0.5693   ? 0.5671  ?0.005  ?0.0058 ?0.5647 ?0.5762 ?
# +-------------------------+------------------------------------------------------------+--------------------------+-----------+----------+--------+--------+--------+--------?
# ?f1_score                ?rgb-genomic_foundation_models/3utrbert-RNA-SSP-rnastralign ?[0.9196, 0.9202, 0.9212] ? 0.9203   ? 0.9202  ?0.0007 ?0.0008 ?0.9196 ?0.9212 ?
# +-------------------------+------------------------------------------------------------+--------------------------+-----------+----------+--------+--------+--------+--------?
# ?root_mean_squared_error ?rgb-genomic_foundation_models/3utrbert-RNA-SNPP            ?[0.2458, 0.2466, 0.2472] ? 0.2465   ? 0.2466  ?0.0006 ?0.0007 ?0.2458 ?0.2472 ?
# +----------------------------------------------------------------------------------------------------------------------------------------------------------------------------+
# -------------------------------------------------------------- https://github.com/yangheng95/metric_visualizer --------------------------------------------------------------

# --------------------------------------------------------------------- Raw Metric Records ---------------------------------------------------------------------
# ╒══════════╤═══════════════════════════════════════════════════════════╤══════════════════════════╤═══════════╤══════════╤════════╤════════╤════════╤════════╕
# │ Metric   │ Trial                                                     │ Values                   │  Average  │  Median  │  Std   │  IQR   │  Min   │  Max   │
# ╞══════════╪═══════════════════════════════════════════════════════════╪══════════════════════════╪═══════════╪══════════╪════════╪════════╪════════╪════════╡
# │ f1_score │ rgb-genomic_foundation_models/cdsBERT-RNA-SSP-Archive2    │ [0.8567, 0.9139, 0.9097] │  0.8934   │  0.9097  │ 0.026  │ 0.0286 │ 0.8567 │ 0.9139 │
# ├──────────┼───────────────────────────────────────────────────────────┼──────────────────────────┼───────────┼──────────┼────────┼────────┼────────┼────────┤
# │ f1_score │ rgb-genomic_foundation_models/cdsBERT-RNA-SSP-bpRNA       │ [0.674, 0.7523, 0.7524]  │  0.7263   │  0.7523  │ 0.0369 │ 0.0392 │ 0.674  │ 0.7524 │
# ├──────────┼───────────────────────────────────────────────────────────┼──────────────────────────┼───────────┼──────────┼────────┼────────┼────────┼────────┤
# │ f1_score │ rgb-genomic_foundation_models/cdsBERT-RNA-SSP-rnastralign │ [0.9685, 0.9733, 0.9726] │  0.9715   │  0.9726  │ 0.0021 │ 0.0024 │ 0.9685 │ 0.9733 │
# ╘══════════╧═══════════════════════════════════════════════════════════╧══════════════════════════╧═══════════╧══════════╧════════╧════════╧════════╧════════╛
# ------------------------------------------------------ https://github.com/yangheng95/metric_visualizer ------------------------------------------------------


# mv = MetricVisualizer(name="rgb-genomic_foundation_models/3utrbert", metric_dict=metric_dict)
# mv.dump("rgb-genomic_foundation_models-3utrbert.mv")


# mv = MetricVisualizer.load(
#     "rgb-genomic_foundation_models-3utrbert.mv"
# )
# metric_dict = {
#     key: {trial_name: metric for trial_name, metric in metric_values.items()} for key, metric_values in mv.metrics.items()
# }
# mv = MetricVisualizer(name="rgb-genomic_foundation_models-3utrbert.mv", metric_dict=metric_dict)
# mv.summary()
# mv.dump("rgb-genomic_foundation_models-3utrbert.mv")

for mv_file in findfile.find_cwd_files(['rgb', '.mv'], recursive=1):
    print(mv_file)
    MetricVisualizer.load(mv_file).summary(round=4)
    print("\n")
